// --- [ kb.h ] ---------------------------------------------------------------
// tabwidth = 3
											// Prescaler fr Timer0 = 64
											// (256 * 64) / 7.372.800 = 2.22ms
#define PRESCALE64 (1<<CS01 | 1<< CS00)

#define PORTDATA	PORTD				// PORT fr Clock und Data der Tastatur
#define PINDATA   PIND				// PIN  fr Clock und Data der Tastatur
#define DDRDATA	DDRD				// DDR  fr Clock und Data-Port
#define DATAPIN	PD4				// Pin  fr Data			
#define CLOCKPIN  PD2				// Pin  fr Clock

											// Bitpositionen in control:
#define CTRL		7					// CTRL     gedrckt	
#define ALT			6					// ALT      gedrckt
#define SHIFT		5					// SHIFT    gedrckt
#define CAPSLOCK	4					// CAPSLOCK aktiv - z.Z. nicht implementiert

#define NUMLOCK	3					// NUMLOCK  aktiv - z.Z. nicht implementiert
#define INSERT		2					// INSERT   aktiv - z.Z. nicht implementiert
#define EXT			1					// Extended Code erkannt
#define BREAK		0					// Break-Code    erkannt

#define PS2_BUFFER 32				// muss 2^x sein (4, 8, 16, 32)
#define PS2_MASK	PS2_BUFFER - 1

#define TRUE		1
#define FALSE		0
											// Kommandos
#define KB_RESET	0xFF				// CMD fr Reset der Tastatur
#define KB_RESEND	0xFE				// CMD fr letztes Zeichen erneut senden (bei Fehler)
#define KB_ECHO	0xEE				// CMD Tastatur sendet 0xEE zurck
#define KB_LED		0xED				// CMD fr LED schalten
#define KB_ACK		0xFA				// ACK - Besttigung durch Tastatur
											// KB_RESEND bei Fehler !
											
#define LED_CAPS	 2					// 1<<2 = 4
#define LED_NUM	 1					// 1<<1 = 2
#define LED_SCROLL 0					// 1<<0 = 1

#ifndef EXTERN
#define EXTERN extern
#endif

EXTERN void    PS2_init(void);
EXTERN uint8_t PS2_cmd(uint8_t cmd);
EXTERN uint8_t PS2_is_byte_in_buffer(void);
EXTERN uint8_t PS2_get_byte_from_buffer(void);

// --- [ eof ] ----------------------------------------------------------------

